# norootforbuild

Summary:	memcached C library and command line tools
Name:		libmemcached
Version:	0.25
Release:	2.1
License:	BSD
Group:		System Environment/Libraries
URL:		http://tangent.org/552/libmemcached.html
Packager:	Carsten Schoene <cs@linux-administrator.com>
Source:		http://download.tangent.org/libmemcached-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
BuildRequires:	gcc-c++

%description
libmemcached is a C client library to the memcached server
(http://danga.com/memcached). It has been designed to be light on memory
usage, and provide full access to server side methods.

It also implements several command line tools:

memcat - Copy the value of a key to standard output.
memflush - Flush the contents of your servers.
memrm - Remove a key(s) from the serrver.
memstat - Dump the stats of your servers to standard output.
memslap - Generate testing loads on a memcached cluster.
memcp - Copy files to memcached servers.
memerror - Creates human readable messages from libmemecached error codes.

%prep
%setup

%configure

%build
%{__make} %{_smp_mflags} || hostname -f

%install
%{__rm} -rf %{buildroot}
%{__make} install  DESTDIR="%{buildroot}" AM_INSTALL_PROGRAM_FLAGS=""

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0755,root,root,-)
%{_bindir}/memcat
%{_bindir}/memcp
%{_bindir}/memerror
%{_bindir}/memflush
%{_bindir}/memrm
%{_bindir}/memstat
%{_bindir}/memslap
%defattr(0644,root,root,-)
%dir %{_includedir}/libmemcached
%{_includedir}/libmemcached/memcached.h
%{_includedir}/libmemcached/memcached.hh
%{_includedir}/libmemcached/libmemcached_config.h
%{_includedir}/libmemcached/memcached_constants.h
%{_includedir}/libmemcached/memcached_result.h
%{_includedir}/libmemcached/memcached_server.h
%{_includedir}/libmemcached/memcached_string.h
%{_includedir}/libmemcached/memcached_types.h
%{_includedir}/libmemcached/memcached_watchpoint.h
%{_includedir}/libmemcached/memcached_storage.h
%{_includedir}/libmemcached/memcached_get.h
%{_libdir}/libmemcached.a
%{_libdir}/libmemcached.la
%attr(0755,root,root) %{_libdir}/libmemcached.so*
%{_libdir}/pkgconfig/libmemcached.pc
%{_mandir}/man1/memcat.1.gz
%{_mandir}/man1/memcp.1.gz
%{_mandir}/man1/memerror.1.gz
%{_mandir}/man1/memflush.1.gz
%{_mandir}/man1/memrm.1.gz
%{_mandir}/man1/memslap.1.gz
%{_mandir}/man1/memstat.1.gz
%{_mandir}/man3/libmemcached.3.gz
%{_mandir}/man3/libmemcached_examples.3.gz
%{_mandir}/man3/memcached_add.3.gz
%{_mandir}/man3/memcached_append.3.gz
%{_mandir}/man3/memcached_behavior_get.3.gz
%{_mandir}/man3/memcached_behavior_set.3.gz
%{_mandir}/man3/memcached_cas.3.gz
%{_mandir}/man3/memcached_clone.3.gz
%{_mandir}/man3/memcached_create.3.gz
%{_mandir}/man3/memcached_decrement.3.gz
%{_mandir}/man3/memcached_delete.3.gz
%{_mandir}/man3/memcached_fetch.3.gz
%{_mandir}/man3/memcached_fetch_result.3.gz
%{_mandir}/man3/memcached_free.3.gz
%{_mandir}/man3/memcached_get.3.gz
%{_mandir}/man3/memcached_increment.3.gz
%{_mandir}/man3/memcached_mget.3.gz
%{_mandir}/man3/memcached_prepend.3.gz
%{_mandir}/man3/memcached_quit.3.gz
%{_mandir}/man3/memcached_replace.3.gz
%{_mandir}/man3/memcached_server_add.3.gz
%{_mandir}/man3/memcached_server_count.3.gz
%{_mandir}/man3/memcached_server_list.3.gz
%{_mandir}/man3/memcached_server_list_append.3.gz
%{_mandir}/man3/memcached_server_list_count.3.gz
%{_mandir}/man3/memcached_server_list_free.3.gz
%{_mandir}/man3/memcached_server_push.3.gz
%{_mandir}/man3/memcached_servers_parse.3.gz
%{_mandir}/man3/memcached_set.3.gz
%{_mandir}/man3/memcached_stat.3.gz
%{_mandir}/man3/memcached_stat_get_keys.3.gz
%{_mandir}/man3/memcached_stat_get_value.3.gz
%{_mandir}/man3/memcached_stat_servername.3.gz
%{_mandir}/man3/memcached_strerror.3.gz
%{_mandir}/man3/memcached_verbosity.3.gz
%{_mandir}/man3/memcached_add_by_key.3.gz
%{_mandir}/man3/memcached_append_by_key.3.gz
%{_mandir}/man3/memcached_callback_get.3.gz
%{_mandir}/man3/memcached_callback_set.3.gz
%{_mandir}/man3/memcached_cas_by_key.3.gz
%{_mandir}/man3/memcached_delete_by_key.3.gz
%{_mandir}/man3/memcached_fetch_execute.3.gz
%{_mandir}/man3/memcached_get_by_key.3.gz
%{_mandir}/man3/memcached_lib_version.3.gz
%{_mandir}/man3/memcached_mget_by_key.3.gz
%{_mandir}/man3/memcached_prepend_by_key.3.gz
%{_mandir}/man3/memcached_replace_by_key.3.gz
%{_mandir}/man3/memcached_set_by_key.3.gz
%{_mandir}/man3/memcached_version.3.gz

%changelog
* Fri Nov 28 2008 Carsten Schoene <cs@linux-administrator.com> - 0.25-1
- version bump to 0.25
 - Jenkins HASH added.
 - Update of Murmur hash code
 - Support explicit weights (Robey Pointer, Evan Weaver)
 - Bugfix for ketama continuum (Robey Pointer)
 - New behavior MEMCACHED_BEHAVIOR_HASH_WITH_PREFIX_KEY (Robey Pointer)

* Mon Sep 10 2008 Carsten Schoene <cs@linux-administrator.com> - 0.23-1
- version bump to 0.23
 - Added strings.h header for Solaris 9
 - Solaris 64bit fix.
 - Support for weighted Ketama from Yin Chen.
 - Fix for Chinese
 - Fix for 0 length key to trigger bad key.
 - Added behaviors MEMCACHED_BEHAVIOR_SND_TIMEOUT, MEMCACHED_BEHAVIOR_RCV_TIMEOUT
 - Support for Binary Protocol added 

* Sat Jul 19 2008 Carsten Schoene <cs@linux-administrator.com> - 0.22-1
- version bump to 0.22
 - Fix where master key was no being checked for "bad key"
 - Fixed bugs in stats output (thread output was wrong)
 - Clarified MEMCACHED_BAD_KEY_PROVIDED is return for bad prefix key.
 - Found a bug in Flags return (Jacek Ostrowski)
 - Fixed issue with compiling on Visual Studio 

* Sat May 24 2008 Carsten Schoene <cs@linux-administrator.com> - 0.21-1
- version bump to 0.21
 - Change of char * to const char * for all key based functions.
 - New MEMCACHED_CALLBACK_PREFIX_KEY added. You can now create domains for values.
 - Fixed bug introducd in last version on memcp
 - Fix for death of file io to call shutdown() 

* Mon May 05 2008 Carsten Schoene <cs@linux-administrator.com> - 0.20-1
- version bump to 0.20
 - New consistent distribution tests.
 - Found a memory leak when a server constantly fails.
 - Fix in watchpoint macro
 - Changed default timeout to 1 second for poll timeouts
 - Wheel uses less memory/dynamic allocation for size (no longer limited to 512 hosts by default).
 - memslap memory leak fix
 - Added Ketama distribution
 - Fix assert.h compile problem on CentOS 

* Wed Apr 09 2008 Carsten Schoene <cs@linux-administrator.com> - 0.19-1
- version bump to 0.19
 - Documentation fix in libmemcached.
 - Fixed bug where sort was always occuring on hosts
 - Logic fix in branch prediction (thanks Jay!)
 - Read through cached support.
 - Fixed for cas by key operation.
 - Fix for memcached_server_st list structures to have correct count.
 - Added callback MEMCACHED_CALLBACK_DELETE_TRIGGER 

* Tue Mar 18 2008 Carsten Schoene <cs@linux-administrator.com> - 0.18-1
- version bump to 0.18
 - Fix plus tests for non-zero value objects and flags.
 - MEMCACHED_HASH_MURMUR added for murmur algorithm provided.
 - MEMCACHED_BEHAVIOR_RETRY_TIMEOUT added to keep connecting from looping on timeout.
 - gcc branch prediction optimizations.
 - Refactored entire tree to make include files cleaner
 - Fixed leaked socket

* Mon Mar 03 2008 Carsten Schoene <cs@linux-administrator.com> - 0.17-1
- version bump to 0.17
 - MEMCACHED_BEHAVIOR_CONNECT_TIMEOUT added for connect timeout in non-block mode.
 - Incompatible change in memcached_behavior_set() api. We now use a uint64_t, instead of a pointer.
 - Fix for storage of values for zero.
 - memcached_server_cursor() function added to API for cycling through servers.

* Tue Feb 19 2008 Carsten Schoene <cs@linux-administrator.com> - 0.16-1
- version bump to 0.16
 - Work on the UDP protocol.
 - Added get_by_key, set_by_key tests for C++ API.
 - Fix for limit_maxbytes to be 64bit in stats.
 - Added Atom Smasher test (scale baby, scale!).
 - Servers are now sorted, meaning that servers are now ordered so that clients with the same lists, 
   will have same distribution. (Idea from Ross McFarland). MEMCACHED_BEHAVIOR_SORT_HOSTS was added to enable this support.
 - Added MEMCACHED_BAD_KEY_PROVIDED error for auto, set, and get operations. MEMCACHED_BEHAVIOR_VERIFY_KEY was added to enable this feature.
 - More error messages on command line tools.
 - Fixed bugs in memcached_cas() operator.
 - Fix to loop through interfaces. 

* Tue Feb 05 2008 Carsten Schoene <cs@linux-administrator.com> - 0.15-1
- version bump to 0.15
 - More work on the C++ API.
 - Bug fixes around block corner cases.
 - Slight performance increase in both read() and write(). 

* Wed Jan 23 2008 Carsten Schoene <cs@linux-administrator.com> - 0.14-1
- version bump to 0.14
 - For for bug found by Evan Weaver where increment() was not returning propper error of value was not found.
 - Fix for bad null pointer on flag by Toru Maesaka.
 - Refactor of all IO to just pass in the active server.
 - Problem configuring (PKG_CHECK_MODULES) fixed by removal of "rpath" in support/libmemcached.pc.in (Thanks to Ross McFarland).
 - Added memcached_callback_get()/set().
 - First prototype of C++ interface.
 - Updated docs for uint16_t changes in previous release.
- version 0.13
 -  MEMCACHED_BEHAVIOR_USER_DATA added to store user pointer.
 - Fix for failure to connect to invalidate socket.
 - Patch from Marc Rossi to add --hash option for memcp, memrm, and memcat.
 - Kevin's patch for fixing EOF issues during a read.
 - Toru Maesaka patch for stats mismatch.
 - Fix for when CRC return 0.
 - Fixed uint16_t issues around flags. Turns out the documentation on the protocol was wrong.
 - Lingering socket fixes for FreeBSD.
 - Patches from Kevin Dalley for FreeBSD 4.0
 - Added multi delete functions.
 - All get key returns have C style null termination.
 - If memcached_server_list_append is passed NULLs instead of pointers it returns NULL.
 - Added memcached_fetch_execute() method.
 - Found a bug where memcached_fetch() was not null terminating the result value.
 - memcached_behavior() now has the ability to set "buffering" so that data is not automatically flushed.
 - Behavior change, buffered commands now return MEMCACHED_BUFFERED.
- version 0.12
 -  Updates for consistent hashing
 - IPV6 support
 - Static allocation for hostname (performance)
 - Fixed bug where in non-block mode all data might not have been sent on close().
 - Refactor of memcached_get() to use common code.
 - Change in value fetch, MEMCACHED_END is now returned when keys are no longer in the pipe.
 - Fixed bug where key could be out of range of characters
 - Added _by_key() methods to allow partitioning of values to particular servers.
 - MEMCACHED_DEFAILT_TIMEOUT is now set to a non -1 value.
 - Performance improvements in get operations. 

* Mon Nov 26 2007 Carsten Schoene <cs@linux-administrator.com> - 0.11-1
- version bump to 0.11
 - Added option to memcache_behavior_set() so that poll() can be timed out.
 - Fixed memory leak in case of using memcached_fetch_result() where no
    value was returned.
 - Bug fixed in memcached_connect() which would cause servers that
    did not need to be enabled to be enabled (performance issue).
 - Rewrote bounds checking code for get calls.
 - "make test" now starts its own memcached servers.
 - Added Hseih hash (MEMCACHED_HASH_HSIEH), which is showing about 7%
    performance over standard hash.

* Sat Nov 24 2007 Carsten Schoene <cs@linux-administrator.com> - 0.10-1
- version bump to 0.10
 - Added append binary test.
 - Added MEMCACHED_BEHAVIOR_CACHE_LOOKUPS behavior so that you can save on
    multiple DNS lookups.
 - Added CAS support, though this is optional and must be enabled during
    runtime.
 - Added the utility memerror to create human readable error strings
    from memcached errors (aka convert ints to strings)
 - Fixed type in MEMCACHED_HOST_LOOKUP_FAILURE
 - Fixed bug where hostname might not be null terminated
 - Moved to using gethostbyname_r() on Linux to solve thread safety issue
 - Added -rpath support for pkg-config
 - Documentation fix for hash setting using 

* Fri Nov 16 2007 Carsten Schoene <cs@linux-administrator.com> - 0.9-1
- version bump to 0.9
 - fix for when no servers are definied.
 - different buffers are now kept for different connections to
   speed up async efforts
 - Modified increment/decrement functions to return uint64_t values
 - Fixed bug in cases where zero length keys were provided
 - Thread cleanup issue in memslap
 - No hostname lookup on reconnect
 - Fix for flag settings (was doing hex by accident!)
 - Support for 1.2.4 server additions "prepend" and "append" added.
 - Added memcached_version()... not sure if I will make this public
   or not.

* Mon Nov  5 2007 Brian Aker <brian@tangent.org> - 0.8-1
- Automated version number

* Wed Oct  3 2007 Brian Aker <brian@tangent.org> - 0.4-1
- See Changelog

* Mon Oct  1 2007 Brian Aker <brian@tangent.org> - 0.3-1
- Added memslap

* Fri Sep 28 2007 Jeff Fisher <guppy@techmonkeys.org> - 0.2-1
- Initial package
